EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_PRESS =
   EFL_EVENT_DESCRIPTION("press");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_LOAD =
   EFL_EVENT_DESCRIPTION("load");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_LOADED =
   EFL_EVENT_DESCRIPTION("loaded");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_LOAD_DETAIL =
   EFL_EVENT_DESCRIPTION("load,detail");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_LOADED_DETAIL =
   EFL_EVENT_DESCRIPTION("loaded,detail");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_DOWNLOAD_START =
   EFL_EVENT_DESCRIPTION("download,start");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_DOWNLOAD_PROGRESS =
   EFL_EVENT_DESCRIPTION("download,progress");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_DOWNLOAD_DONE =
   EFL_EVENT_DESCRIPTION("download,done");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_IMAGE_ZOOMABLE_EVENT_DOWNLOAD_ERROR =
   EFL_EVENT_DESCRIPTION("download,error");

void _efl_ui_image_zoomable_gesture_enabled_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Bool gesture);


static Eina_Error
__eolian_efl_ui_image_zoomable_gesture_enabled_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_image_zoomable_gesture_enabled_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_image_zoomable_gesture_enabled_set, EFL_FUNC_CALL(gesture), Eina_Bool gesture);

Eina_Bool _efl_ui_image_zoomable_gesture_enabled_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


static Eina_Value
__eolian_efl_ui_image_zoomable_gesture_enabled_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_image_zoomable_gesture_enabled_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_image_zoomable_gesture_enabled_get, Eina_Bool, 0);

void _efl_ui_image_zoomable_image_region_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Rect region);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_image_zoomable_image_region_set, EFL_FUNC_CALL(region), Eina_Rect region);

Eina_Rect _efl_ui_image_zoomable_image_region_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_image_zoomable_image_region_get, Eina_Rect, (EINA_RECT_EMPTY()));

Efl_Object *_efl_ui_image_zoomable_efl_object_constructor(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_gfx_entity_position_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Position2D pos);


void _efl_ui_image_zoomable_efl_gfx_entity_size_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Size2D size);


Eina_Size2D _efl_ui_image_zoomable_efl_gfx_view_view_size_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Size2D _efl_ui_image_zoomable_efl_gfx_image_image_size_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Bool _efl_ui_image_zoomable_efl_ui_image_icon_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, const char *name);


const char *_efl_ui_image_zoomable_efl_ui_image_icon_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Bool _efl_ui_image_zoomable_efl_playable_playable_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Bool _efl_ui_image_zoomable_efl_player_playing_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Bool playing);


Eina_Bool _efl_ui_image_zoomable_efl_player_playing_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Bool _efl_ui_image_zoomable_efl_player_paused_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Bool paused);


Eina_Bool _efl_ui_image_zoomable_efl_player_paused_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_player_playback_position_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, double sec);


double _efl_ui_image_zoomable_efl_player_playback_position_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_player_playback_progress_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, double progress);


double _efl_ui_image_zoomable_efl_player_playback_progress_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_player_playback_speed_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, double speed);


double _efl_ui_image_zoomable_efl_player_playback_speed_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_player_autoplay_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Bool autoplay);


Eina_Bool _efl_ui_image_zoomable_efl_player_autoplay_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_player_playback_loop_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Bool looping);


Eina_Bool _efl_ui_image_zoomable_efl_player_playback_loop_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_ui_zoom_zoom_animation_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Bool paused);


Eina_Bool _efl_ui_image_zoomable_efl_ui_zoom_zoom_animation_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_ui_zoom_zoom_level_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, double zoom);


double _efl_ui_image_zoomable_efl_ui_zoom_zoom_level_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_ui_zoom_zoom_mode_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Efl_Ui_Zoom_Mode mode);


Efl_Ui_Zoom_Mode _efl_ui_image_zoomable_efl_ui_zoom_zoom_mode_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_canvas_group_group_member_add(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Efl_Canvas_Object *sub_obj);


Eina_Error _efl_ui_image_zoomable_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Bool _efl_ui_image_zoomable_efl_ui_focus_object_on_focus_update(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Bool _efl_ui_image_zoomable_efl_ui_widget_widget_input_event_handler(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, const Efl_Event *eo_event, Efl_Canvas_Object *source);


void _efl_ui_image_zoomable_efl_ui_scrollable_scroll(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Eina_Rect rect, Eina_Bool animation);


const Efl_Access_Action_Data *_efl_ui_image_zoomable_efl_access_widget_action_elm_actions_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Error _efl_ui_image_zoomable_efl_file_load(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_file_unload(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Error _efl_ui_image_zoomable_efl_file_file_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, const char *file);


const char *_efl_ui_image_zoomable_efl_file_file_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


void _efl_ui_image_zoomable_efl_gfx_image_orientable_image_orientation_set(Eo *obj, Efl_Ui_Image_Zoomable_Data *pd, Efl_Gfx_Image_Orientation dir);


Efl_Gfx_Image_Orientation _efl_ui_image_zoomable_efl_gfx_image_orientable_image_orientation_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Size2D _efl_ui_image_zoomable_efl_layout_group_group_size_min_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


Eina_Size2D _efl_ui_image_zoomable_efl_layout_group_group_size_max_get(const Eo *obj, Efl_Ui_Image_Zoomable_Data *pd);


static Eina_Bool
_efl_ui_image_zoomable_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_IMAGE_ZOOMABLE_EXTRA_OPS
#define EFL_UI_IMAGE_ZOOMABLE_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_image_zoomable_gesture_enabled_set, _efl_ui_image_zoomable_gesture_enabled_set),
      EFL_OBJECT_OP_FUNC(efl_ui_image_zoomable_gesture_enabled_get, _efl_ui_image_zoomable_gesture_enabled_get),
      EFL_OBJECT_OP_FUNC(efl_ui_image_zoomable_image_region_set, _efl_ui_image_zoomable_image_region_set),
      EFL_OBJECT_OP_FUNC(efl_ui_image_zoomable_image_region_get, _efl_ui_image_zoomable_image_region_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_image_zoomable_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_position_set, _efl_ui_image_zoomable_efl_gfx_entity_position_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_size_set, _efl_ui_image_zoomable_efl_gfx_entity_size_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_view_size_get, _efl_ui_image_zoomable_efl_gfx_view_view_size_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_size_get, _efl_ui_image_zoomable_efl_gfx_image_image_size_get),
      EFL_OBJECT_OP_FUNC(efl_ui_image_icon_set, _efl_ui_image_zoomable_efl_ui_image_icon_set),
      EFL_OBJECT_OP_FUNC(efl_ui_image_icon_get, _efl_ui_image_zoomable_efl_ui_image_icon_get),
      EFL_OBJECT_OP_FUNC(efl_playable_get, _efl_ui_image_zoomable_efl_playable_playable_get),
      EFL_OBJECT_OP_FUNC(efl_player_playing_set, _efl_ui_image_zoomable_efl_player_playing_set),
      EFL_OBJECT_OP_FUNC(efl_player_playing_get, _efl_ui_image_zoomable_efl_player_playing_get),
      EFL_OBJECT_OP_FUNC(efl_player_paused_set, _efl_ui_image_zoomable_efl_player_paused_set),
      EFL_OBJECT_OP_FUNC(efl_player_paused_get, _efl_ui_image_zoomable_efl_player_paused_get),
      EFL_OBJECT_OP_FUNC(efl_player_playback_position_set, _efl_ui_image_zoomable_efl_player_playback_position_set),
      EFL_OBJECT_OP_FUNC(efl_player_playback_position_get, _efl_ui_image_zoomable_efl_player_playback_position_get),
      EFL_OBJECT_OP_FUNC(efl_player_playback_progress_set, _efl_ui_image_zoomable_efl_player_playback_progress_set),
      EFL_OBJECT_OP_FUNC(efl_player_playback_progress_get, _efl_ui_image_zoomable_efl_player_playback_progress_get),
      EFL_OBJECT_OP_FUNC(efl_player_playback_speed_set, _efl_ui_image_zoomable_efl_player_playback_speed_set),
      EFL_OBJECT_OP_FUNC(efl_player_playback_speed_get, _efl_ui_image_zoomable_efl_player_playback_speed_get),
      EFL_OBJECT_OP_FUNC(efl_player_autoplay_set, _efl_ui_image_zoomable_efl_player_autoplay_set),
      EFL_OBJECT_OP_FUNC(efl_player_autoplay_get, _efl_ui_image_zoomable_efl_player_autoplay_get),
      EFL_OBJECT_OP_FUNC(efl_player_playback_loop_set, _efl_ui_image_zoomable_efl_player_playback_loop_set),
      EFL_OBJECT_OP_FUNC(efl_player_playback_loop_get, _efl_ui_image_zoomable_efl_player_playback_loop_get),
      EFL_OBJECT_OP_FUNC(efl_ui_zoom_animation_set, _efl_ui_image_zoomable_efl_ui_zoom_zoom_animation_set),
      EFL_OBJECT_OP_FUNC(efl_ui_zoom_animation_get, _efl_ui_image_zoomable_efl_ui_zoom_zoom_animation_get),
      EFL_OBJECT_OP_FUNC(efl_ui_zoom_level_set, _efl_ui_image_zoomable_efl_ui_zoom_zoom_level_set),
      EFL_OBJECT_OP_FUNC(efl_ui_zoom_level_get, _efl_ui_image_zoomable_efl_ui_zoom_zoom_level_get),
      EFL_OBJECT_OP_FUNC(efl_ui_zoom_mode_set, _efl_ui_image_zoomable_efl_ui_zoom_zoom_mode_set),
      EFL_OBJECT_OP_FUNC(efl_ui_zoom_mode_get, _efl_ui_image_zoomable_efl_ui_zoom_zoom_mode_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_member_add, _efl_ui_image_zoomable_efl_canvas_group_group_member_add),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_image_zoomable_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_on_focus_update, _efl_ui_image_zoomable_efl_ui_focus_object_on_focus_update),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_input_event_handler, _efl_ui_image_zoomable_efl_ui_widget_widget_input_event_handler),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll, _efl_ui_image_zoomable_efl_ui_scrollable_scroll),
      EFL_OBJECT_OP_FUNC(efl_access_widget_action_elm_actions_get, _efl_ui_image_zoomable_efl_access_widget_action_elm_actions_get),
      EFL_OBJECT_OP_FUNC(efl_file_load, _efl_ui_image_zoomable_efl_file_load),
      EFL_OBJECT_OP_FUNC(efl_file_unload, _efl_ui_image_zoomable_efl_file_unload),
      EFL_OBJECT_OP_FUNC(efl_file_set, _efl_ui_image_zoomable_efl_file_file_set),
      EFL_OBJECT_OP_FUNC(efl_file_get, _efl_ui_image_zoomable_efl_file_file_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_orientation_set, _efl_ui_image_zoomable_efl_gfx_image_orientable_image_orientation_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_orientation_get, _efl_ui_image_zoomable_efl_gfx_image_orientable_image_orientation_get),
      EFL_OBJECT_OP_FUNC(efl_layout_group_size_min_get, _efl_ui_image_zoomable_efl_layout_group_group_size_min_get),
      EFL_OBJECT_OP_FUNC(efl_layout_group_size_max_get, _efl_ui_image_zoomable_efl_layout_group_group_size_max_get),
      EFL_UI_IMAGE_ZOOMABLE_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"gesture_enabled", __eolian_efl_ui_image_zoomable_gesture_enabled_set_reflect, __eolian_efl_ui_image_zoomable_gesture_enabled_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_image_zoomable_class_desc = {
   EO_VERSION,
   "Efl.Ui.Image_Zoomable",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Image_Zoomable_Data),
   _efl_ui_image_zoomable_class_initializer,
   _efl_ui_image_zoomable_class_constructor,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_image_zoomable_class_get, &_efl_ui_image_zoomable_class_desc, EFL_UI_IMAGE_CLASS, EFL_UI_ZOOM_INTERFACE, EFL_UI_SCROLLABLE_INTERFACE, EFL_UI_SCROLLBAR_INTERFACE, NULL);
